;tasten
Const LINKS = 203
Const RECHTS = 205
Const OBEN = 200
Const UNTEN = 208

Graphics 1024,768,16,2
SetBuffer BackBuffer()

AppTitle "BCC 89 - Krumu1201"

frametimer = CreateTimer(60)

;grafiken
Global spieler_bild = LoadImage ("Grafiken/spieler.png")
Global ziel = LoadImage("grafiken/ziel.png")
Global kuerbis = LoadImage ("Grafiken/kuerbis.png")
MaskImage kuerbis,255,0,255
Global kuerbis_markiert = LoadImage ("Grafiken/kuerbis_markiert.png")
MaskImage kuerbis_markiert,255,0,255
Global sueses = LoadImage("grafiken/sueses.png")
Global Weg = LoadImage("grafiken/weg.png")
Global wand = LoadImage("Grafiken/wand.png")
Global leer = LoadImage("Grafiken/leer_tile.png")



;spielerdaten
Type TSpieler
	Field x
	Field y
	Field geschwindigkeit
	Field xZucker
End Type

Dim spielerFeld.TSpieler(0)

For i = 0 To 0
	spielerFeld(i) = New TSpieler
	
Next

Global spielerfeldx = 1
Global spielerfeldy = 9
Global xmapkol,ymapkol

;weltdateien
Global level = 1
Global modus$="karte" ;vorhandene Modi karte und level

Type Tworldmap
	Field x
	Field y
	Field markiert
	Field geschafft
	Field levelStatusText$
	Field bild
End Type

Dim worldmapFeld.Tworldmap(5)

;initWorldmap
For i = 1 To 5
	worldmapFeld(i) = New Tworldmap
	worldmapFeld(i)\markiert = 0
	worldmapFeld(i)\geschafft = 0
Next

worldmapFeld(1)\markiert = 1



worldmapFeld(1)\x = 200
worldmapFeld(1)\y = 300

worldmapFeld(2)\x = 450
worldmapFeld(2)\y = 150

worldmapFeld(3)\x = 700
worldmapFeld(3)\y = 300

worldmapFeld(4)\x = 450
worldmapFeld(4)\y = 500

worldmapFeld(5)\x = 450
worldmapFeld(5)\y = 300







;level
Const SPALTEN = 15
Const ZEILEN = 11
Const TILE_SIZE = 64

Type LevelTile
	Field x
	Field y
	Field tile
End Type

Dim levelFeld.LevelTile(SPALTEN,ZEILEN)

For zeile = 0 To ZEILEN
	For spalte = 0 To SPALTEN
		levelFeld(spalte,zeile) = New LevelTile
		levelFeld(spalte,zeile)\tile = leer
	Next
Next

Dim levelDatenFeld$(SPALTEN,ZEILEN)

;suesigkeiten
Type TSueses
	Field x
	Field y
	Field bild
	Field zuffzahlBild
	Field da
End Type

Dim SuesesFeld.TSueses(9)

For i = 0 To 9
	SuesesFeld(i) = New TSueses
	SuesesFeld(i)\x = Rand(25,990)
	SuesesFeld(i)\y = Rand(25,500)
	SuesesFeld(i)\da = 1
	SuesesFeld(i)\bild = sueses
Next

Global counter

Global punkte

Global durchgespielt

spielerInit()
map_laden()
map_zuweisen()
Repeat
	WaitTimer(frametimer)
	Cls
	If durchgespielt = 0 Then 
		If modus = "karte" Then 
			karte()
		Else
			starteLevel()
			map_zeichnen()
			spieler()
			status_leiste()
		EndIf
	Else
		endefunktion()
	EndIf
	Flip 0
Until KeyHit(1)
End

Function endefunktion()
	Text 10,10,"Glckwunsch du hast das Spiel durchgespielt."
	Text 10,20,"Punktzahl: "+punkte
	Text 10,30,"Escape fr ende
End Function

Function karte()
	;geschaffte level mit pfeiltasten durchgehen
	If worldmapFeld(level)\geschafft = 1 Then 
		If KeyHit(RECHTS) Then level = level +1
	EndIf
	If KeyHit(LINKS) Then level = level -1
	
	If level < 1 Then level = 1
	If level > 5 Then level = 5
	
	For k = 1 To 5
		worldmapFeld(k)\markiert = 0
	Next
	worldmapFeld(level)\markiert = 1
	
	Text 10,10,"aktuelles Level: "+level
	
	;level beginnen
	If KeyHit(28) Or KeyHit(156) Then modus = "level"

	;Hintergrund
	ClsColor 34,177,76
	
	;level auf karte zeichnen
	For k = 1 To 5
		If worldmapFeld(k)\markiert = 1 Then 
			worldmapFeld(k)\bild = kuerbis_markiert
		Else
			worldmapFeld(k)\bild = kuerbis
		EndIf
		If worldmapFeld(k)\geschafft = 0 Then 
			worldmapFeld(k)\levelStatusText ="Nicht geschafft"
		Else
			worldmapFeld(k)\levelStatusText ="Geschafft"
		EndIf
		Text worldmapFeld(k)\x-45,worldmapFeld(k)\y-20,worldmapFeld(k)\levelStatusText
		DrawImage worldmapFeld(k)\bild,worldmapFeld(k)\x,worldmapFeld(k)\y 
	Next
	
	Text 10,30,"Aktuelle Punktzahl "+punkte
End Function

Function map_laden()
    Local spalte =0
	Local zeile = 0
	Local levelDatei = ReadFile("Level/Level"+level+".dat")
	
	For zeile = 0 To ZEILEN
		Local TextZeile$ = ReadLine$(levelDatei)
		For spalte = 0 To SPALTEN
			levelDatenFeld(spalte,zeile) = Mid$(TextZeile$,spalte+1,1)
		Next
	Next
	
	CloseFile levelDatei
End Function

Function map_zeichnen()
	Local zeile = 0
	Local spalte = 0
	
	For zeile = 0 To ZEILEN
		For spalte = 0 To SPALTEN
			DrawImage (levelFeld(spalte,zeile)\tile,spalte*TILE_SIZE,zeile*TILE_SIZE+64)
		Next
	Next
End Function

Function map_zuweisen()
	For Zeile = 0 To ZEILEN
		For Spalte = 0 To SPALTEN
			If levelDatenFeld(spalte,zeile) = "0" Then levelFeld(spalte,zeile)\tile = leer
			If levelDatenFeld(spalte,zeile) = "1" Then levelFeld(spalte,zeile)\tile = Weg
			If levelDatenFeld(spalte,zeile) = "2" Then levelFeld(spalte,zeile)\tile = wand
			If levelDatenFeld(spalte,zeile) = "3" Then levelFeld(spalte,zeile)\tile = ziel
			If levelDatenFeld(spalte,zeile) = "4" Then levelFeld(spalte,zeile)\tile = sueses
		Next
	Next
End Function

Function spieler()
	;spieler bewegen
	If KeyHit(LINKS) Then
		xmapkol = spielerfeldx -1
		If xmapkol < 0 Then xmapkol = 0
		If levelDatenFeld(xmapkol,spielerfeldy) = 1 Or levelDatenFeld(xmapkol,spielerfeldy) = 4  Then 
			spielerFeld(0)\x = spielerFeld(0)\x -spielerFeld(0)\geschwindigkeit
			spielerfeldx = spielerfeldx -1
			If spielerfeldx < 0 Then spielerfeldx = 0
		EndIf
	End If
	If KeyHit(RECHTS) Then
		xmapkol = spielerfeldx +1
		If xmapkol > 15 Then xmapkol = 15
		If levelDatenFeld(xmapkol,spielerfeldy) = 1 Or levelDatenFeld(xmapkol,spielerfeldy) = 4  Then 
			spielerFeld(0)\x = spielerFeld(0)\x +spielerFeld(0)\geschwindigkeit
			spielerfeldx = spielerfeldx +1
			If spielerfeldx > 15 Then spielerfeldx = 15
		EndIf
	EndIf
	If KeyHit(OBEN) Then
		ymapkol = spielerfeldy -1
		If ymapkol < 0 Then ymapkol = 0
		If levelDatenFeld(spielerfeldx,ymapkol) = 1 Or levelDatenFeld(spielerfeldx,ymapkol) = 4  Then 
			spielerFeld(0)\y = spielerFeld(0)\y -spielerFeld(0)\geschwindigkeit
			spielerfeldy = spielerfeldy-1
			If spielerfeldy < 0 Then spielerfeldy = 0
		EndIf
	End If	
	If KeyHit(UNTEN) Then
		ymapkol = spielerfeldy +1
		If ymapkol > 10 Then ymapkol = 10
		If levelDatenFeld(spielerfeldx,ymapkol) = 1 Or levelDatenFeld(spielerfeldx,ymapkol) = 4  Then 
			spielerFeld(0)\y = spielerFeld(0)\y +spielerFeld(0)\geschwindigkeit
			spielerfeldy = spielerfeldy +1
			If spielerfeldy > 10 Then spielerfeldy = 10
		EndIf
	End If
	
	;suees sammeln
	If levelDatenFeld(spielerfeldx,spielerfeldy) = 4 Then 
		levelDatenFeld(spielerfeldx,spielerfeldy) = 1
		map_zuweisen()
		spielerFeld(0)\xZucker = spielerFeld(0)\xZucker +10
		punkte = punkte +10
	EndIf
	
	;zuckerspiegel geht runter
	counter = counter +1
	
	If counter = 50 Then spielerFeld(0)\xZucker = spielerFeld(0)\xZucker-10
	
	If counter > 50 Then counter = 1
	
	If spielerFeld(0)\xZucker = 0 Then modus ="karte"
	
	;spieler zeichnen
	DrawImage spieler_bild,spielerFeld(0)\x,spielerFeld(0)\y
End Function

Function spielerInit()
	spielerFeld(0)\x = 64
	spielerFeld(0)\y = 640
	spielerFeld(0)\geschwindigkeit = 64
	spielerFeld(0)\xZucker = 100
	spielerfeldy = 9
	spielerfeldx = 1
	xmapkol =0 
	ymapkol = 0
End Function

Function starteLevel()
	;hintergrund
	ClsColor 0,0,0
	
	If levelDatenFeld(spielerfeldx,ymapkol) = 3 Or levelDatenFeld(xmapkol,spielerfeldy) = 3 Then 
		FlushKeys()
		worldmapFeld(level)\geschafft = 1
		If level <5 Then level = level +1
		map_laden()
		map_zuweisen()
		spielerInit()
		modus = "karte"
		If worldmapFeld(5)\geschafft = 1 Then durchgespielt = 1
	EndIf
End Function

Function status_leiste()
	;zuckerleiste
	Color 255,255,255
	Rect 800,50,100,10
	Color 255,0,0
	Rect 800,50,spielerFeld(0)\xZucker,10
	Color 255,255,255
	Text 800,30,"Zuckerspiegel"
	Text 400,30,"Punkte "+punkte
	
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D